﻿



namespace Microsoft.Dynamics.Retail.Ecommerce.Sdk.Core
{
    using System.Collections.Generic;
    using System.Composition.Hosting;
    using System.ServiceModel.Web;
    using Microsoft.Dynamics.Commerce.Runtime;
    using Microsoft.Dynamics.Commerce.Runtime.Configuration;
    using Microsoft.Dynamics.Commerce.Runtime.Data;
    using Microsoft.Dynamics.Retail.Ecommerce.Sdk.Core.Storefront.Models;

    public class ExtendedCommerceRuntimeConfiguration : ICommerceRuntimeConfiguration
    {
        private CommerceRuntimeConfiguration _commerceRuntimeConfiguration;

        public ExtendedCommerceRuntimeConfiguration(CommerceRuntimeConfiguration commerceRuntimeConfiguration)
        {
            _commerceRuntimeConfiguration = commerceRuntimeConfiguration;
        }

        public ContainerConfiguration AggregateCatalog
        {
            get { return _commerceRuntimeConfiguration.AggregateCatalog; }
        }

        public ICacheControlElement CacheControl
        {
            get
            {
                return _commerceRuntimeConfiguration.CacheControl;
            }
            set
            {
                _commerceRuntimeConfiguration.CacheControl = value;
            }
        }

        public ICompositionLoader Composition
        {
            get { return _commerceRuntimeConfiguration.Composition; }
        }

        public string ConnectionString
        {
            get
            {
                return _commerceRuntimeConfiguration.ConnectionString;
            }
            set
            {
                _commerceRuntimeConfiguration.ConnectionString = value;
            }
        }

        public IDictionary<string, string> DataAccessSettings
        {
            get { return _commerceRuntimeConfiguration.DataAccessSettings; }
        }

        public IDatabaseProvider DatabaseProvider
        {
            get { return _commerceRuntimeConfiguration.DatabaseProvider; }
        }

        public void Initialize()
        {
            _commerceRuntimeConfiguration.Initialize();
        }

        public bool IsConnectionStringOverridden
        {
            get { return _commerceRuntimeConfiguration.IsConnectionStringOverridden; }
        }

        public IStorageElement Storage
        {
            get
            {
                if (WebOperationContext.Current != null)
                {
                    var oun = WebOperationContext.Current.IncomingRequest.Headers["oun"];
                    if (!string.IsNullOrEmpty(oun))
                    {
                        var storage = new ExtendedStorageElement();
                        storage.DefaultOperatingUnitNumber = oun;
                        return storage;
                    }
                }

                return _commerceRuntimeConfiguration.Storage;
            }
        }
    }
}
